/*
 * 机具转换明细
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MachineChangeDetailController : BaseController
    {
        public MachineChangeDetailController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具转换明细列表

        /// <summary>
        /// 根据条件查询机具转换明细列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MachineChangeDetail data, string right, string ChangeId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ChangeId = ChangeId;


            string Condition = "";
            Condition += "ChangeNo:\"" + data.ChangeNo + "\",";
            Condition += "BackProductType:\"" + data.BackProductType + "\",";
            Condition += "BackDeviceStatus:\"" + data.BackDeviceStatus + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询机具转换明细列表

        /// <summary>
        /// 机具转换明细列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MachineChangeDetail data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ChangeId", "1");

            Fields.Add("ChangeNo", "2"); //订单号
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("BackProductType", "1"); //退回产品类型
            Fields.Add("BackDeviceStatus", "1"); //设备状态

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineChangeDetail", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具转换明细

        /// <summary>
        /// 增加或修改机具转换明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string ChangeId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ChangeId = ChangeId;


            return View();
        }

        #endregion

        #region 增加机具转换明细

        /// <summary>
        /// 增加或修改机具转换明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MachineChangeDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ChangeId", data.ChangeId);

            Fields.Add("BackProductType", data.BackProductType); //退回产品类型
            Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MachineChangeDetail", Fields, 0);
            AddSysLog(data.Id.ToString(), "MachineChangeDetail", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具转换明细

        /// <summary>
        /// 增加或修改机具转换明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string ChangeId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ChangeId = ChangeId;


            MachineChangeDetail editData = db.MachineChangeDetail.FirstOrDefault(m => m.Id == Id) ?? new MachineChangeDetail();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具转换明细

        /// <summary>
        /// 增加或修改机具转换明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MachineChangeDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ChangeId", data.ChangeId);

            Fields.Add("BackProductType", data.BackProductType); //退回产品类型
            Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChangeDetail", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "MachineChangeDetail", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具转换明细信息

        /// <summary>
        /// 删除机具转换明细信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineChangeDetail", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChangeDetail", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineChangeDetail", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChangeDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineChangeDetail", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChangeDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MachineChangeDetail", Sort, Id);

            AddSysLog(Id.ToString(), "MachineChangeDetail", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MachineChangeDetail.Add(new MachineChangeDetail()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MachineChangeDetail", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MachineChangeDetail data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ChangeNo", "2"); //订单号
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("BackProductType", "1"); //退回产品类型
            Fields.Add("BackDeviceStatus", "1"); //设备状态

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineChangeDetail", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MachineChangeDetail", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
